#include "IMUSensor.h"

MPU6050 sensor; 

IMUSensor::IMUSensor()
{
}

void IMUSensor::Init(void)
{
    Wire.begin();           //Iniciando I2C  
    sensor.initialize();    //Iniciando el sensor
    if (sensor.testConnection()) Serial.println("IMU Init OK");
    else Serial.println("ERROR: IMU init");
}

void IMUSensor::read(void)
{
    sensor.getAcceleration(&ax, &ay, &az);
    sensor.getRotation(&gx, &gy, &gz);    
}

float IMUSensor::getRealAcceleration(void)
{
    IMUSensor::read();    
    return (abs((9.81/16384.0) * sqrt(pow(ax,2) + pow(ay,2)+ pow(az,2)) - 9.81) / 9.81)*100/2.4;

}


void IMUSensor::computeAngle(void)
{
    IMUSensor::read();

    dt = (millis()-time_prev)/1000.0;
    time_prev=millis();
  
    //angle calculation
    float accel_ang_x=atan(-ay/sqrt(0 + pow(az,2)))*(180.0/3.14);
    float accel_ang_y=atan(ax/sqrt(0 + pow(az,2)))*(180.0/3.14);
  
  //use complementary filter 
    ang_x = 0.97*(ang_x_prev+(gx/131)*dt) + 0.03*accel_ang_x;
    ang_y = 0.97*(ang_y_prev+(gy/131)*dt) + 0.03*accel_ang_y;
  
    ang_x_prev=ang_x;
    ang_y_prev=ang_y;
}

float IMUSensor::getAngle_X(void)
{
    return ang_x;
}

float IMUSensor::getAngle_Y(void)
{
    return ang_y;
}