/**
 * \par Copyright (C), 2012-2016, Parconier
 * \brief   Driver for OTUS robotics kit.
 * @file    OTUS.h
 * @author  Parconier
 * @version V1.0.0
 * @date    2019/01/31
 * @brief   Driver for OTUS robotics kit.
 *
 * \par Copyright
 * This software is Copyright (C), 2012-2019, Parconier. Use is subject to license \n
 * conditions. The main licensing options available are GPL V2 or Commercial: \n
 *
 * \par Open Source Licensing GPL V2
 * This is the appropriate option if you want to share the source code of your \n
 * application with everyone you distribute it to, and you also want to give them \n
 * the right to share who uses it. If you wish to use this software under Open \n
 * Source Licensing, you must contribute all your source code to the open source \n
 * community in accordance with the GPL Version 2 when your application is \n
 * distributed. See http://www.gnu.org/copyleft/gpl.html
 *
 * \par Description
 * This file is the driver for OTUS robotics kit by Parconier.
 *
 * \par History:
 * <pre>
 * `<Author>`         `<Time>`        `<Version>`        `<Descr>`
 * Gonzalo Gutierrez         2019/01/31     1.0.0            Rebuild the old lib.
 * </pre>
 */
#ifndef OTUS_H
#define OTUS_H

#include <Arduino.h>
#include "DCMotor.h"
#include "MotorEncoder.h"
#include "IMUSensor.h"

//MOTOR A
#define MA_ENC_OUTA  2
#define MA_ENC_OUTB  4  //12
#define MA_PWM       5  //6 timer0
#define MA_DIR       12 //7


//MOTOR B
#define MB_ENC_OUTA  3
#define MB_ENC_OUTB  8  //9
#define MB_PWM       11 //5 timer2
#define MB_DIR       13 //4



Motor_slot_type Motor_Slot[2] = 
{
  //id            ENA A            ENA B         PWM         DIR
  { MA,     MA_ENC_OUTA,     MA_ENC_OUTB,     MA_PWM,     MA_DIR},
  //id            ENA A            ENA B         PWM         DIR
  { MB,     MB_ENC_OUTA,     MB_ENC_OUTB,     MB_PWM,     MB_DIR},
};

#endif // OTUS_H